/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: AP.C,v 2.43 2004/06/17 23:04:27 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* hummel  02/03/98  created
* aaguayo 04/12/02  removed warning (APR2003)
*/

/************************************************************************
*   NAME
*   AP - Automatic Positioning main C++ 
* 
*   SYNOPSIS
#       AP filname 
* 
*   DESCRIPTION
*       - creates an instance of TARG_set 
*       - loads an target list from an external file
*       - creates an instance of AP_mask
*       - moves and rotates the the AP_mask in order
*       - to find a best-fit mask position.
*       - saves results in a target acquisition file
*
*   FILES
*       AP.C AP.h
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*       TARG, TARG_set, AP_mask
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#define MAX_TARG  8

// Uncomment this if you are using the VLT environment
// #include "vltPort.h"


#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <math.h>

#include "AP_pixel.h"
#include "AP_mask.h"
#include "AP_targ.h"
#include "AP_list.h"
using namespace std;

static char *rcsId="@(#) $Id: AP.C,v 2.43 2004/06/17 23:04:27 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

int main(int argc, char *argv[])
{
  int i;
  i=argc;

  int debug=0;

  if (debug) {
  AP_pixel p; p.test();
  AP_mask  m; m.test();


  // test functions of class TARG, defined in AP_targ.C
  cout << "test all functions of class TARG, defined in AP_targ.C" << endl;
  cout << "------------------------------------------------------" << endl; 
  //        name              alp    del   pixX  pixY mag  prio
  TARG one("GSC086546546543", 10.0, -70.2, 100, 200, 23.4, 1);
  cout << "TARG constructed ok\n"; 
  one.print();
  cout << "TARG printed ok \n";
  cout << one.get_nam() << "/" << one.get_RA() << "/" << one.get_DEC() << "/" << 
          one.get_px() << "/" << one.get_py() << "/" <<
          one.get_MAG() << "/" << one.get_PRI() << endl;
  cout << "TARG get methods ok \n";
  one.set_RA(30.00); one.set_DEC(-30.0); 
  one.set_px(50.3); one.set_py(1456.99); 
  one.set_MAG(30.0); one.set_PRI(0); one.set_nam("SHORT_NAME");
  cout << "TARG set methods ok \n";
  one.print();
  cout << "TARG print method ok \n";
  one.set_RA(29.00); one.set_DEC(-30.0); one.set_MAG(8.5); 
  one.set_px(1250.3); one.set_py(0.333); 
  one.set_PRI(1); one.set_nam("NN");
  cout << "TARG set methods ok \n";
  one.print();
  cout << "TARG print method ok \n";
  }
 



  // create one instance of class TARG_set, defined in AP_list.C
  TARG_set k;


/*
  cout << " declared ok\n"; 

  for (i=0; i<MAX_TARG; i++) 
      {
      k.add("GSC000012345", 10.+1.0*i, -10.0-1.0*i, 1.5*i, 1.3*i, 1.0*i, i-(i/2)*2 );
      }  
  cout << "initialized ok\n";

  k.print(); cout << "printed ok\n";

  k.delete_by_index(2); cout << "deleted ok\n";

  k.print(); cout << "printed ok\n";

  k.set_by_index(4,"HR0815",20.234,-30.00); cout << "set_by_index ok\n";

  k.print(); cout << "printed ok\n";

  cout << "RA mean = " << k.a_mean() << "  DEC mean = " << k.d_mean() << endl; 
  cout << "X  mean = " << k.x_mean() << "  Y   mean = " << k.y_mean() << endl; 
*/


  if (debug) {
     cout << "test finished" << endl << "   ___oOo___   " << endl;
     return 0;
     }

 
  // no more tests, now real life 
  // fill the instance, read from a file 
  k.load_from_file(argv[1]);

  // k.print(); cout << "printed ok\n";
  // fit best mask position to  list 
  k.fit_list(); 


  // k.print(); cout << "printed ok\n";

  k.delete_all();
  // cout << "AP.C  end\n";
  return 0;


}








